<?php

namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use \Teknisa\Model\Traits\TQuery;

class Sm00005000TabParametrizacoesEmailFactory
{
    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getParametrosEmailFilial()
    {
        $sql = "SELECT EMAIL.NRPARAMEMAILFILIAL,
                        EMAIL.CDFILIAL,
                        EMAIL.DSREMETENTEEMAIL,
                        EMAIL.DSASSUNTOEMAIL,
                        EMAIL.DSCORPOEMAIL,
                        EMAIL.NRORG,
                        EMAIL.DTINCLUSAO,
                        EMAIL.DTULTATU,
                        EMAIL.NRORGINCLUSAO,
                        EMAIL.CDOPERINCLUSAO,
                        EMAIL.NRORGULTATU,
                        EMAIL.CDOPERULTATU,
                        EMAIL.IDATIVO,
                        FILIAL.NMFILIAL
                FROM FCT_PARAMEMAILFILIAL EMAIL
                LEFT JOIN FILIAL ON EMAIL.CDFILIAL = FILIAL.CDFILIAL";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function validaRegistrosDuplicados($params)
    {

        $sql = "SELECT COUNT (*) AS QTD 
                FROM FCT_PARAMEMAILFILIAL
                WHERE CDFILIAL      = :CDFILIAL
                AND NRPARAMEMAILFILIAL <> NVL(:NRPARAMEMAILFILIAL, -1)";

        return $this->connection->executeQuery($sql, $params)->fetchAllAssociative();
    }

    public function updateParameterEmail($params)
    {
        $sql = "UPDATE FCT_PARAMEMAILFILIAL
                   SET CDFILIAL         = :CDFILIAL,
                       DSREMETENTEEMAIL = :DSREMETENTEEMAIL,
                       DSASSUNTOEMAIL   = :DSASSUNTOEMAIL,
                       DSCORPOEMAIL   = :DSCORPOEMAIL,
                       NRORG          = :NRORG,
                       DTULTATU       = SYSDATE,
                       CDOPERULTATU   = :CDOPERULTATU,
                       IDATIVO        = :IDATIVO
                 WHERE NRPARAMEMAILFILIAL = :NRPARAMEMAILFILIAL";

        $this->connection->executeStatement($sql, $params);
    }

    public function insertParameterEmail($params)
    {
        $sql = "INSERT INTO FCT_PARAMEMAILFILIAL(
                    NRPARAMEMAILFILIAL, CDFILIAL, DSREMETENTEEMAIL, DSASSUNTOEMAIL, DSCORPOEMAIL,
                    NRORG, DTINCLUSAO, CDOPERINCLUSAO, IDATIVO)
                VALUES(
                    :NRPARAMEMAILFILIAL, :CDFILIAL, :DSREMETENTEEMAIL, :DSASSUNTOEMAIL, :DSCORPOEMAIL,
                    :NRORG, SYSDATE, :CDOPERINCLUSAO, :IDATIVO)";

        $this->connection->executeStatement($sql, $params);
    }

    public function deleteParametrosEmail($params)
    {
        $sql = "DELETE FROM FCT_PARAMEMAILFILIAL WHERE NRPARAMEMAILFILIAL = :NRPARAMEMAILFILIAL";
        $this->connection->executeStatement($sql, $params);
    }
}
