<?php

namespace SM\Service;

use SM\Factory\Sm00004101RelatorioCustomizavelContratoFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;
use SM\Service\FindService;

class Sm00004101RelatorioCustomizavelContratoService
{

    protected $connection;
    protected $RelatorioCustomizavelContratoFactory;
    protected $environment;
    protected $newCode;
    protected $FindService;
    
    public function __construct(Sm00004101RelatorioCustomizavelContratoFactory $RelatorioCustomizavelContratoFactory, Environment $environment, NewCode $newCode, EntityManager $entityManager, FindService $FindService)
    {
        $this->RelatorioCustomizavelContratoFactory = $RelatorioCustomizavelContratoFactory;
        $this->environment                  = $environment;
        $this->newCode                      = $newCode;
        $this->connection                   = $entityManager->getConnection();
        $this->FindService                  = $FindService;
    }

    public function getRelatorioCustomizavelContrato($parametros)
    {
        $cont = 0;
        $filtro = '';

        if (isset($parametros["NRMOTIVOPARALISACAO"])) {
            $nrmotivoparalisacao = $this->FindService->formatarArray($parametros["NRMOTIVOPARALISACAO"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_PARAMPARALISACAOCONT.NRMOTIVOPARALISACAO IN ($nrmotivoparalisacao) ";
            $cont++;
        }

        if (isset($parametros["PARAOPERADOR"])) {
            $paraoperador = $this->FindService->formatarArray($parametros["PARAOPERADOR"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_PARAMPARALISACAOCONT.CDOPERINCLUSAO IN ($paraoperador) ";
            $cont++;
        }

        if (isset($parametros['PARADATA'])) {
            $dataInicial = $parametros['PARADATA'][0];
            $dataFinal = array_key_exists("1", $parametros['PARADATA']) ? $parametros['PARADATA'][1] : null;

            if ($dataFinal != null) {
                $filtro = $filtro .(($cont > 0) ? " AND " : " WHERE "). " FCT_PARAMPARALISACAOCONT.DTINIPARALISACAO BETWEEN '" . $dataInicial . "' AND '" . $dataFinal . "' ";
                $cont++;
            } else {
                $data = $dataInicial;
                $filtro = $filtro .(($cont > 0) ? " AND " : " WHERE ")." FCT_PARAMPARALISACAOCONT.DTINIPARALISACAO BETWEEN '" . $data . "' AND TO_DATE('" . $data . "')+30 ";
                $cont++;
            }
        }

        if (isset($parametros["NRSEQMODCONTRA"])) {
            $modcontra = $this->FindService->formatarArray($parametros["NRSEQMODCONTRA"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_CONTRATO.NRSEQMODCONTRA IN ($modcontra) ";
            $cont++;
        }

        if (isset($parametros["NRSEQCONTRATO"])) {
            $contrato = $this->FindService->formatarArray($parametros["NRSEQCONTRATO"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_CONTRATO.NRSEQCONTRATO IN ($contrato) ";
            $cont++;
        }

        if (isset($parametros["NRPARCNEGOCIO"])) {
            $nrparcnegocio = $this->FindService->formatarArray($parametros["NRPARCNEGOCIO"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_CONTRATO.NRPARCNEGOCIO IN ($nrparcnegocio) ";
            $cont++;
        }
        
        if (isset($parametros["NRSEQORCAMENTO"])) {
            $proposta = $this->FindService->formatarArray($parametros["NRSEQORCAMENTO"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_REFEORCACONT.NRSEQORCAMENTO IN ($proposta) ";
            $cont++;
        }

        if (isset($parametros["IDATIVO"])) {
            $idativo = $parametros["IDATIVO"];
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_CONTRATO.IDATIVO = '$idativo'";
            $cont++;
        }

        if (isset($parametros["IDSITUACAOCONTRATO"])) {
            $idsituacao = $this->FindService->formatarArray($parametros["IDSITUACAOCONTRATO"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_CONTRATO.IDSITUACAOCONTRATO IN ($idsituacao) ";
            $cont++;
        }

        if (isset($parametros["CDFILIAL"])) {
            $filial = $this->FindService->formatarArray($parametros["CDFILIAL"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_CONTRATO.CDFILIALORCA IN ($filial) ";
            $cont++;
        }

        if (isset($parametros["NRVERSAOCONTRATO"])) {
            $nrversao = $this->FindService->formatarArray($parametros["NRVERSAOCONTRATO"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_CONTRATO.NRVERSAOCONTRATO IN ($nrversao) ";
            $cont++;
        }

        if (isset($parametros["NRTIPOORCAMENTO"])) {
            $nrTipoOrcamento = $this->FindService->formatarArray($parametros["NRTIPOORCAMENTO"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_CONTRATO.NRTIPOORCAMENTO IN ($nrTipoOrcamento) ";
            $cont++;
        }

        if (isset($parametros["CDOPERRESPONSAVEL"])) {
            $operadorResponsavel = $this->FindService->formatarArray($parametros["CDOPERRESPONSAVEL"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_CONTRATO.CDOPERRESPONSAVEL IN ($operadorResponsavel) ";
            $cont++;
        }
        
        if (isset($parametros["NRORCAMENTOMODELO"])) {
            $modeloorcamento = $this->FindService->formatarArray($parametros["NRORCAMENTOMODELO"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_CONTRATO.NRORCAMENTOMODELO IN ($modeloorcamento) ";
            $cont++;
        }

        if (isset($parametros["CDCENTCUST"])) {
            $centcusto = $this->FindService->formatarArray($parametros["CDCENTCUST"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_CONTRATO.CDCENTCUST IN ($centcusto) ";
            $cont++;
        }

        if (isset($parametros["CDTPMEDIDASERV"])) {
            $tipoMedida = $this->FindService->formatarArray($parametros["CDTPMEDIDASERV"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_ITEMCONTRATO.CDTPMEDIDAVARIAVEL IN ($tipoMedida) ";
            $cont++;
        }

        if (isset($parametros["CDSERVORCA"])) {
            $cdservorca = $this->FindService->formatarArray($parametros["CDSERVORCA"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_ITEMCONTRATO.CDSERVORCA IN ($cdservorca) ";
            $cont++;
        }
        
        if (isset($parametros["IDELEMENTO"])) {
            $idelemento = $this->FindService->formatarArray($parametros["IDELEMENTO"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_ITEMCONTRATO.IDELEMENTO IN ($idelemento) ";
            $cont++;
        }

        if (isset($parametros['DTINICIOCONTRATO'])) {
            $dataInicial = $parametros['DTINICIOCONTRATO'][0];
            $dataFinal = array_key_exists("1", $parametros['DTINICIOCONTRATO']) ? $parametros['DTINICIOCONTRATO'][1] : null;

            if ($dataFinal != null) {
                $filtro = $filtro .(($cont > 0) ? " AND " : " WHERE "). " FCT_CONTRATO.DTINICIOCONTRATO BETWEEN '" . $dataInicial . "' AND '" . $dataFinal . "' ";
                $cont++;
            } else {
                $data = $dataInicial;
                $filtro = $filtro .(($cont > 0) ? " AND " : " WHERE ")." FCT_CONTRATO.DTINICIOCONTRATO BETWEEN '" . $data . "' AND TO_DATE('" . $data . "')+30 ";
                $cont++;
            }
        }

        if (isset($parametros['DTFIMCONTRATO'])) {
            $dataInicial = $parametros['DTFIMCONTRATO'][0];
            $dataFinal = array_key_exists("1", $parametros['DTFIMCONTRATO']) ? $parametros['DTFIMCONTRATO'][1] : null;

            if ($dataFinal != null) {
                $filtro = $filtro .(($cont > 0) ? " AND " : " WHERE "). " FCT_CONTRATO.DTFIMCONTRATO BETWEEN '" . $dataInicial . "' AND '" . $dataFinal . "' ";
                $cont++;
            } else {
                $data = $dataInicial;
                $filtro = $filtro .(($cont > 0) ? " AND " : " WHERE ")." FCT_CONTRATO.DTFIMCONTRATO BETWEEN '" . $data . "' AND TO_DATE('" . $data . "')+30 ";
                $cont++;
            }
        }

        if (isset($parametros['DTINICONTRATO'])) {
            $dataInicial = $parametros['DTINICONTRATO'][0];
            $dataFinal = array_key_exists("1", $parametros['DTINICONTRATO']) ? $parametros['DTINICONTRATO'][1] : null;

            if ($dataFinal != null) {
                $filtro = $filtro .(($cont > 0) ? " AND " : " WHERE "). " DTINICONTRATO BETWEEN '" . $dataInicial . "' AND '" . $dataFinal . "' ";
                $cont++;
            } else {
                $data = $dataInicial;
                $filtro = $filtro .(($cont > 0) ? " AND " : " WHERE ")." DTINICONTRATO BETWEEN '" . $data . "' AND TO_DATE('" . $data . "')+30 ";
                $cont++;
            }
        }

        if (isset($parametros['DTFINCONTRATO'])) {
            $dataInicial = $parametros['DTFINCONTRATO'][0];
            $dataFinal = array_key_exists("1", $parametros['DTFINCONTRATO']) ? $parametros['DTFINCONTRATO'][1] : null;

            if ($dataFinal != null) {
                $filtro = $filtro .(($cont > 0) ? " AND " : " WHERE "). " DTFINCONTRATO BETWEEN '" . $dataInicial . "' AND '" . $dataFinal . "' ";
                $cont++;
            } else {
                $data = $dataInicial;
                $filtro = $filtro .(($cont > 0) ? " AND " : " WHERE ")." DTFINCONTRATO BETWEEN '" . $data . "' AND TO_DATE('" . $data . "')+30 ";
                $cont++;
            }
        }

        if (isset($parametros['DTRECISAOCONTR'])) {
            $dataInicial = $parametros['DTRECISAOCONTR'][0];
            $dataFinal = array_key_exists("1", $parametros['DTRECISAOCONTR']) ? $parametros['DTRECISAOCONTR'][1] : null;

            if ($dataFinal != null) {
                $filtro = $filtro .(($cont > 0) ? " AND " : " WHERE "). " FCT_CONTRATO.DTRECISAOCONTR BETWEEN '" . $dataInicial . "' AND '" . $dataFinal . "' ";
                $cont++;
            } else {
                $data = $dataInicial;
                $filtro = $filtro .(($cont > 0) ? " AND " : " WHERE ")." FCT_CONTRATO.DTRECISAOCONTR BETWEEN '" . $data . "' AND TO_DATE('" . $data . "')+30 ";
                $cont++;
            }
        }

        return $this->RelatorioCustomizavelContratoFactory->getRelatorioCustomizavelContrato($filtro);
    }

    // public function getItensRelatorioCustomizavel($parametros)
    // {
    //     $cont = 0;
    //     $filtro = '';

    //     if (isset($parametros["NRSEQORCAMENTO"])) {
    //         $proposta = $this->FindService->formatarArray($parametros["NRSEQORCAMENTO"]);
    //         $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_ITEMORCAMENTO.NRSEQORCAMENTO IN ($proposta) ";
    //         $cont++;
    //     }

    //     if (isset($parametros["NRPARCNEGOCIO"])) {
    //         $nrparcnegocio = $this->FindService->formatarArray($parametros["NRPARCNEGOCIO"]);
    //         $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_ORCAMENTO.NRPARCNEGOCIO IN ($nrparcnegocio) ";
    //         $cont++;
    //     }
        
    //     if (isset($parametros["CDSERVORCA"])) {
    //         $cdservorca = $this->FindService->formatarArray($parametros["CDSERVORCA"]);
    //         $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_ITEMORCAMENTO.CDSERVORCA IN ($cdservorca) ";
    //         $cont++;
    //     }
        
    //     if (isset($parametros["IDELEMENTO"])) {
    //         $idelemento = $this->FindService->formatarArray($parametros["IDELEMENTO"]);
    //         $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_ITEMORCAMENTO.IDELEMENTO IN ($idelemento) ";
    //         $cont++;
    //     }
        
    //     return $this->RelatorioCustomizavelContratoFactory->getItensRelatorioCustomizavel($filtro);
    // }

    public function getPropostaRelatorioContrato()
    {
        return $this->RelatorioCustomizavelContratoFactory->getPropostaRelatorioContrato(array(
            "CDOPERADOR" => $this->environment->getCdOperador(),
        ));
    }

    public function getItensRelatorioContrato($parametros)
    {
        $cont = 0;
        $filtro = '';

        if (isset($parametros["NRSEQCONTRATO"])) {
            $proposta = $this->FindService->formatarArray($parametros["NRSEQCONTRATO"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_ITEMCONTRATO.NRSEQCONTRATO IN ($proposta) ";
            $cont++;
        }

        if (isset($parametros["NRPARCNEGOCIO"])) {
            $nrparcnegocio = $this->FindService->formatarArray($parametros["NRPARCNEGOCIO"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_CONTRATO.NRPARCNEGOCIO IN ($nrparcnegocio) ";
            $cont++;
        }
        
        if (isset($parametros["CDSERVORCA"])) {
            $cdservorca = $this->FindService->formatarArray($parametros["CDSERVORCA"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_ITEMCONTRATO.CDSERVORCA IN ($cdservorca) ";
            $cont++;
        }
        
        if (isset($parametros["IDELEMENTO"])) {
            $idelemento = $this->FindService->formatarArray($parametros["IDELEMENTO"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_ITEMCONTRATO.IDELEMENTO IN ($idelemento) ";
            $cont++;
        }

        if (isset($parametros["CDTPMEDIDASERV"])) {
            $tipoMedida = $this->FindService->formatarArray($parametros["CDTPMEDIDASERV"]);
            $filtro = $filtro.(($cont > 0) ? " AND " : " WHERE ")." FCT_ITEMCONTRATO.CDTPMEDIDASERV IN ($tipoMedida) ";
            $cont++;
        }
    
        return $this->RelatorioCustomizavelContratoFactory->getItensRelatorioContrato($filtro);
    }

    public function getMotivoParalisacao()
    {    
        return $this->RelatorioCustomizavelContratoFactory->getMotivoParalisacao();
    }
}
